

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.Localisation &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../../index.html" />
    <link rel="up" title="Module code" href="../index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for pywws.Localisation</h1><div class="highlight"><pre>
<span class="c">#!/usr/bin/env python</span>
<span class="c"># -*- coding: utf-8 -*-</span>

<span class="sd">&quot;&quot;&quot;Localisation.py - provide translations of strings into local</span>
<span class="sd">language</span>

<span class="sd">::</span>

<span class="sd">%s</span>

<span class="sd">Introduction</span>
<span class="sd">------------</span>

<span class="sd">Some of the pywws modules, such as WindRose.py, can automatically use</span>
<span class="sd">your local language for such things as wind directions. The</span>
<span class="sd">Localisation.py module, mostly copied from examples in the Python</span>
<span class="sd">documentation, enables this.</span>

<span class="sd">Localisation of pywws is done in two parts - translating strings such</span>
<span class="sd">as &#39;rising very rapidly&#39;, and changing the &#39;locale&#39; which controls</span>
<span class="sd">things like month names and number representation (e.g. &#39;23,2&#39; instead</span>
<span class="sd">of &#39;23.2&#39;). On some computers it may not be possible to set the</span>
<span class="sd">locale, but translated strings can still be used.</span>

<span class="sd">Using a different language</span>
<span class="sd">--------------------------</span>

<span class="sd">The language used by pywws is set in the ``[config]`` section of the</span>
<span class="sd">``weather.ini`` file. This can be a two-letter language code, such as</span>
<span class="sd">``en`` (English), or can specify a national variant, such as ``fr_CA``</span>
<span class="sd">(Canadian French). It could also include a character set, for example</span>
<span class="sd">``de_DE.UTF-8``.</span>

<span class="sd">The choice of language is very system dependant, so Localisation.py</span>
<span class="sd">can be run as a standalone program to test language codes. A good</span>
<span class="sd">starting point might be your system&#39;s ``LANG`` environment variable,</span>
<span class="sd">for example::</span>

<span class="sd">    jim@brains:~/Documents/weather/devel$ echo $LANG</span>
<span class="sd">    en_GB.UTF-8</span>
<span class="sd">    jim@brains:~/Documents/weather/devel$ python pywws/Localisation.py -t en_GB.UTF-8</span>
<span class="sd">    Locale changed from (None, None) to (&#39;en_GB&#39;, &#39;UTF8&#39;)</span>
<span class="sd">    Translation set OK</span>
<span class="sd">    Locale</span>
<span class="sd">      decimal point: 23.2</span>
<span class="sd">      date &amp; time: Friday, 14 October (14/10/11 13:02:00)</span>
<span class="sd">    Translations</span>
<span class="sd">      &#39;NNW&#39; =&gt; &#39;NNW&#39;</span>
<span class="sd">      &#39;rising very rapidly&#39; =&gt; &#39;rising very rapidly&#39;</span>
<span class="sd">      &#39;Rain at times, very unsettled&#39; =&gt; &#39;Rain at times, very unsettled&#39;</span>
<span class="sd">    jim@brains:~/Documents/weather/devel$</span>

<span class="sd">In most cases no more than a two-letter code is required::</span>

<span class="sd">    jim@brains:~/Documents/weather/devel$ python pywws/Localisation.py -t fr</span>
<span class="sd">    Locale changed from (None, None) to (&#39;fr_FR&#39;, &#39;UTF8&#39;)</span>
<span class="sd">    Translation set OK</span>
<span class="sd">    Locale</span>
<span class="sd">      decimal point: 23,2</span>
<span class="sd">      date &amp; time: vendredi, 14 octobre (14/10/2011 13:04:44)</span>
<span class="sd">    Translations</span>
<span class="sd">      &#39;NNW&#39; =&gt; &#39;NNO&#39;</span>
<span class="sd">      &#39;rising very rapidly&#39; =&gt; &#39;en hausse très rapide&#39;</span>
<span class="sd">      &#39;Rain at times, very unsettled&#39; =&gt; &#39;Quelques précipitations, très perturbé&#39;</span>
<span class="sd">    jim@brains:~/Documents/weather/devel$</span>

<span class="sd">If you try an unsupported language, pywws falls back to English::</span>

<span class="sd">    jim@brains:~/Documents/weather/devel$ python pywws/Localisation.py -t ja</span>
<span class="sd">    Failed to set locale: ja</span>
<span class="sd">    No translation file found for: ja</span>
<span class="sd">    Locale</span>
<span class="sd">      decimal point: 23.2</span>
<span class="sd">      date &amp; time: Friday, 14 October (10/14/11 13:08:49)</span>
<span class="sd">    Translations</span>
<span class="sd">      &#39;NNW&#39; =&gt; &#39;NNW&#39;</span>
<span class="sd">      &#39;rising very rapidly&#39; =&gt; &#39;rising very rapidly&#39;</span>
<span class="sd">      &#39;Rain at times, very unsettled&#39; =&gt; &#39;Rain at times, very unsettled&#39;</span>
<span class="sd">    jim@brains:~/Documents/weather/devel$</span>

<span class="sd">Once you&#39;ve found a suitable language code that works, you can</span>
<span class="sd">configure pywws to use it by editing your ``weather.ini`` file::</span>

<span class="sd"> [config]</span>
<span class="sd"> language = fr</span>

<span class="sd">Creating a new translation</span>
<span class="sd">--------------------------</span>

<span class="sd">If there is no translation file for your preferred language then you</span>
<span class="sd">need to create one. See :doc:`../guides/language` for detailed</span>
<span class="sd">instructions.</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__docformat__</span> <span class="o">=</span> <span class="s">&quot;restructuredtext en&quot;</span>

<span class="n">__usage__</span> <span class="o">=</span> <span class="s">&quot;&quot;&quot;</span>
<span class="s"> usage: python pywws/Localisation.py [options]</span>
<span class="s"> options are:</span>
<span class="s">  -h       or  --help       display this help</span>
<span class="s">  -t code  or  --test code  test use of a language code</span>
<span class="s">&quot;&quot;&quot;</span>

<span class="n">__doc__</span> <span class="o">%=</span> <span class="n">__usage__</span>
<span class="n">__usage__</span> <span class="o">=</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s">&#39;</span><span class="se">\n</span><span class="s">&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">__usage__</span>

<span class="kn">import</span> <span class="nn">getopt</span>
<span class="kn">import</span> <span class="nn">gettext</span>
<span class="kn">import</span> <span class="nn">locale</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">time</span>

<span class="c"># set translation to be used if SetTranslation is not called</span>
<span class="n">translation</span> <span class="o">=</span> <span class="n">gettext</span><span class="o">.</span><span class="n">NullTranslations</span><span class="p">()</span>

<div class="viewcode-block" id="SetLocale"><a class="viewcode-back" href="../../api/pywws.Localisation.html#pywws.Localisation.SetLocale">[docs]</a><span class="k">def</span> <span class="nf">SetLocale</span><span class="p">(</span><span class="n">lang</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Set the &#39;locale&#39; used by a program.</span>

<span class="sd">    This affects the entire application, changing the way dates,</span>
<span class="sd">    currencies and numbers are represented. It should not be called</span>
<span class="sd">    from a library routine that may be used in another program.</span>

<span class="sd">    The ``lang`` parameter can be any string that is recognised by</span>
<span class="sd">    ``locale.setlocale()``, for example ``en``, ``en_GB`` or ``en_GB.UTF-8``.</span>

<span class="sd">    :param lang: language code.</span>
<span class="sd">    :type lang: string</span>
<span class="sd">    :return: success status.</span>
<span class="sd">    :rtype: bool</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c"># get the default locale</span>
    <span class="n">lc</span><span class="p">,</span> <span class="n">encoding</span> <span class="o">=</span> <span class="n">locale</span><span class="o">.</span><span class="n">getdefaultlocale</span><span class="p">()</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">if</span> <span class="s">&#39;.&#39;</span> <span class="ow">in</span> <span class="n">lang</span><span class="p">:</span>
            <span class="n">locale</span><span class="o">.</span><span class="n">setlocale</span><span class="p">(</span><span class="n">locale</span><span class="o">.</span><span class="n">LC_ALL</span><span class="p">,</span> <span class="n">lang</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">locale</span><span class="o">.</span><span class="n">setlocale</span><span class="p">(</span><span class="n">locale</span><span class="o">.</span><span class="n">LC_ALL</span><span class="p">,</span> <span class="p">(</span><span class="n">lang</span><span class="p">,</span> <span class="n">encoding</span><span class="p">))</span>
    <span class="k">except</span> <span class="n">locale</span><span class="o">.</span><span class="n">Error</span><span class="p">:</span>
        <span class="k">return</span> <span class="bp">False</span>
    <span class="k">return</span> <span class="bp">True</span>
</div>
<div class="viewcode-block" id="SetTranslation"><a class="viewcode-back" href="../../api/pywws.Localisation.html#pywws.Localisation.SetTranslation">[docs]</a><span class="k">def</span> <span class="nf">SetTranslation</span><span class="p">(</span><span class="n">lang</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Set the translation used by (some) pywws modules.</span>

<span class="sd">    This sets the translation object ``Localisation.translation`` to</span>
<span class="sd">    use a particular language.</span>

<span class="sd">    The ``lang`` parameter can be any string of the form ``en``,</span>
<span class="sd">    ``en_GB`` or ``en_GB.UTF-8``. Anything after a ``.`` character is</span>
<span class="sd">    ignored. In the case of a string such as ``en_GB``, the routine</span>
<span class="sd">    will search for an ``en_GB`` language file before searching for an</span>
<span class="sd">    ``en`` one.</span>

<span class="sd">    :param lang: language code.</span>
<span class="sd">    :type lang: string</span>
<span class="sd">    :return: success status.</span>
<span class="sd">    :rtype: bool</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">global</span> <span class="n">translation</span>
    <span class="c"># make list of possible languages, in order of preference</span>
    <span class="n">langs</span> <span class="o">=</span> <span class="nb">list</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">lang</span><span class="p">:</span>
        <span class="k">if</span> <span class="s">&#39;.&#39;</span> <span class="ow">in</span> <span class="n">lang</span><span class="p">:</span>
            <span class="n">lang</span> <span class="o">=</span> <span class="n">lang</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s">&#39;.&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">langs</span> <span class="o">+=</span> <span class="p">[</span><span class="n">lang</span><span class="p">,</span> <span class="n">lang</span><span class="p">[:</span><span class="mi">2</span><span class="p">]]</span>
    <span class="c"># get translation object</span>
    <span class="n">path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span> <span class="s">&#39;..&#39;</span><span class="p">,</span> <span class="s">&#39;locale&#39;</span><span class="p">)</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">path</span><span class="p">):</span>
        <span class="n">path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span> <span class="s">&#39;locale&#39;</span><span class="p">)</span>
    <span class="n">codeset</span> <span class="o">=</span> <span class="n">locale</span><span class="o">.</span><span class="n">getpreferredencoding</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">codeset</span> <span class="o">==</span> <span class="s">&#39;ASCII&#39;</span><span class="p">:</span>
        <span class="n">codeset</span> <span class="o">=</span> <span class="s">&#39;UTF-8&#39;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">translation</span> <span class="o">=</span> <span class="n">gettext</span><span class="o">.</span><span class="n">translation</span><span class="p">(</span>
            <span class="s">&#39;pywws&#39;</span><span class="p">,</span> <span class="n">path</span><span class="p">,</span> <span class="n">languages</span><span class="o">=</span><span class="n">langs</span><span class="p">,</span> <span class="n">codeset</span><span class="o">=</span><span class="n">codeset</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">IOError</span><span class="p">:</span>
        <span class="k">return</span> <span class="bp">False</span>
    <span class="k">return</span> <span class="bp">True</span>
</div>
<div class="viewcode-block" id="SetApplicationLanguage"><a class="viewcode-back" href="../../api/pywws.Localisation.html#pywws.Localisation.SetApplicationLanguage">[docs]</a><span class="k">def</span> <span class="nf">SetApplicationLanguage</span><span class="p">(</span><span class="n">params</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Set the locale and translation for a pywws program.</span>

<span class="sd">    This function reads the language from the configuration file, then</span>
<span class="sd">    calls :func:`SetLocale` and :func:`SetTranslation`.</span>

<span class="sd">    :param params: a :class:`pywws.DataStore.params` object.</span>

<span class="sd">    :type params: object</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">lang</span> <span class="o">=</span> <span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;config&#39;</span><span class="p">,</span> <span class="s">&#39;language&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">lang</span><span class="p">:</span>
        <span class="n">SetLocale</span><span class="p">(</span><span class="n">lang</span><span class="p">)</span>
        <span class="n">SetTranslation</span><span class="p">(</span><span class="n">lang</span><span class="p">)</span>
</div>
<div class="viewcode-block" id="main"><a class="viewcode-back" href="../../api/pywws.Localisation.html#pywws.Localisation.main">[docs]</a><span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">argv</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">argv</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
        <span class="n">argv</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">opts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">getopt</span><span class="o">.</span><span class="n">getopt</span><span class="p">(</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">:],</span> <span class="s">&quot;ht:&quot;</span><span class="p">,</span> <span class="p">[</span><span class="s">&#39;help&#39;</span><span class="p">,</span> <span class="s">&#39;test=&#39;</span><span class="p">])</span>
    <span class="k">except</span> <span class="n">getopt</span><span class="o">.</span><span class="n">error</span><span class="p">,</span> <span class="n">msg</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">msg</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">1</span>
    <span class="c"># process options</span>
    <span class="n">code</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="k">for</span> <span class="n">o</span><span class="p">,</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">opts</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-h&#39;</span><span class="p">,</span> <span class="s">&#39;--help&#39;</span><span class="p">):</span>
            <span class="k">print</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
            <span class="k">return</span> <span class="mi">0</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-t&#39;</span><span class="p">,</span> <span class="s">&#39;--test&#39;</span><span class="p">):</span>
            <span class="n">code</span> <span class="o">=</span> <span class="n">a</span>
    <span class="c"># check arguments</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: no arguments required</span><span class="se">\n</span><span class="s">&#39;</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">2</span>
    <span class="c"># test language code</span>
    <span class="k">if</span> <span class="n">code</span><span class="p">:</span>
        <span class="n">old_locale</span> <span class="o">=</span> <span class="n">locale</span><span class="o">.</span><span class="n">getlocale</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">SetLocale</span><span class="p">(</span><span class="n">code</span><span class="p">):</span>
            <span class="n">new_locale</span> <span class="o">=</span> <span class="n">locale</span><span class="o">.</span><span class="n">getlocale</span><span class="p">()</span>
            <span class="k">print</span> <span class="s">&quot;Locale changed from&quot;</span><span class="p">,</span> <span class="n">old_locale</span><span class="p">,</span> <span class="s">&quot;to&quot;</span><span class="p">,</span> <span class="n">new_locale</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">print</span> <span class="s">&quot;Failed to set locale:&quot;</span><span class="p">,</span> <span class="n">code</span>
        <span class="k">if</span> <span class="n">SetTranslation</span><span class="p">(</span><span class="n">code</span><span class="p">):</span>
            <span class="k">print</span> <span class="s">&quot;Translation set OK&quot;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">print</span> <span class="s">&quot;No translation file found for:&quot;</span><span class="p">,</span> <span class="n">code</span>
    <span class="c"># try a few locale / translation effects</span>
    <span class="k">print</span> <span class="s">&quot;Locale&quot;</span>
    <span class="k">print</span> <span class="s">&quot;  decimal point:&quot;</span><span class="p">,</span> <span class="n">locale</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="s">&quot;</span><span class="si">%4.1f</span><span class="s">&quot;</span><span class="p">,</span> <span class="mf">23.2</span><span class="p">)</span>
    <span class="k">print</span> <span class="s">&quot;  date &amp; time:&quot;</span><span class="p">,</span> <span class="n">time</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s">&quot;%A, </span><span class="si">%d</span><span class="s"> %B (</span><span class="si">%x</span><span class="s"> </span><span class="si">%X</span><span class="s">)&quot;</span><span class="p">)</span>
    <span class="k">print</span> <span class="s">&quot;Translations&quot;</span>
    <span class="k">print</span> <span class="s">&quot;  &#39;NNW&#39; =&gt; &#39;</span><span class="si">%s</span><span class="s">&#39;&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">translation</span><span class="o">.</span><span class="n">lgettext</span><span class="p">(</span><span class="s">&#39;NNW&#39;</span><span class="p">))</span>
    <span class="k">print</span> <span class="s">&quot;  &#39;rising very rapidly&#39; =&gt; &#39;</span><span class="si">%s</span><span class="s">&#39;&quot;</span> <span class="o">%</span> <span class="p">(</span>
        <span class="n">translation</span><span class="o">.</span><span class="n">lgettext</span><span class="p">(</span><span class="s">&#39;rising very rapidly&#39;</span><span class="p">))</span>
    <span class="k">print</span> <span class="s">&quot;  &#39;Rain at times, very unsettled&#39; =&gt; &#39;</span><span class="si">%s</span><span class="s">&#39;&quot;</span> <span class="o">%</span> <span class="p">(</span>
        <span class="n">translation</span><span class="o">.</span><span class="n">lgettext</span><span class="p">(</span><span class="s">&#39;Rain at times, very unsettled&#39;</span><span class="p">))</span>
    <span class="k">return</span> <span class="mi">0</span>
</div>
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="n">main</span><span class="p">())</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>